"use strict";

var canvas;
var gl;

var maxNumPositions  = 200;
var index = 0;
var cindex = 0;
var t = []; //vertices 
var tt; //vec4 color
var numPolygons = 0;
var numPositions = [];
numPositions[0] = 0;
var start = [0];
var first = true;
var ObjShape = "";
var drawArraysConfig = {};
var SHAPES = []; // list dari gambar yang dibuat
var speed = 100;
var spin = false;
var glob_theta = 0.0;
var thetaLoc;
var speed = 10;

init();

function init() {

    canvas = document.getElementById("gl-canvas");
    gl = canvas.getContext('webgl2');
    if (!gl) alert("WebGL 2.0 isn't available");

    gl.viewport(0, 0, canvas.width, canvas.height);
    gl.clearColor(1., 1., 1., 1.0);
    gl.clear(gl.COLOR_BUFFER_BIT);

    //
    //  Load shaders and initialize attribute buffers
    //
    var program = initShaders(gl, "vertex-shader", "fragment-shader");
    gl.useProgram(program);

    var bufferId = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, bufferId);
    gl.bufferData(gl.ARRAY_BUFFER, 8*maxNumPositions, gl.STATIC_DRAW);
    var postionLoc = gl.getAttribLocation(program, "aPosition");
    gl.vertexAttribPointer(postionLoc, 2, gl.FLOAT, false, 0, 0);
    gl.enableVertexAttribArray(postionLoc);

    var cBufferId = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, cBufferId);
    gl.bufferData(gl.ARRAY_BUFFER, 16*maxNumPositions, gl.STATIC_DRAW);
    var colorLoc = gl.getAttribLocation(program, "aColor");
    gl.vertexAttribPointer(colorLoc, 4, gl.FLOAT, false, 0, 0);
    gl.enableVertexAttribArray(colorLoc);
    
    thetaLoc = gl.getUniformLocation(program, "uTheta");

    // variabel untuk warna dengan input sesuai user
    const red = document.getElementById("red");
    const green = document.getElementById("green");
    const blue = document.getElementById("blue");
    const color = document.getElementById("color");

    red.addEventListener("input", updateColor);
    green.addEventListener("input", updateColor);
    blue.addEventListener("input", updateColor);

    updateColor();

    document.getElementById('polygon').addEventListener('click', function() {
        ObjShape = 'polygon';
        console.log("jadi polygon")
    });
    document.getElementById('rectangle').addEventListener('click', function() {
        ObjShape = 'rectangle';
    });
    document.getElementById('triangle').addEventListener('click', function() {
        ObjShape = 'triangle';
    });
    document.getElementById('line').addEventListener('click', function() {
        ObjShape = 'line';
    });
    


    var a = document.getElementById("end-polygon")
    a.addEventListener("click", function(){
        if(ObjShape == "polygon"){
            numPolygons++;
            numPositions[numPolygons] = 0;
            start[numPolygons] = index;
            drawArraysConfig = {
                "nama": ObjShape,
                "mode": gl.TRIANGLE_FAN,
                "index": index - numPositions[numPolygons-1],
                "step": numPositions[numPolygons - 1]
            }
            // reset vertices & menambahkan ke gambar yang dibuat
            SHAPES.push(drawArraysConfig)
            t = []
            render()
        }
    });
    
    // button untuk menghapus gambar
    var clearButton = document.getElementById("clear")
    clearButton.addEventListener("click", function() {
        index = 0;
        SHAPES = [];
    })

    // button untuk animasi rotasi
    var animateButton = document.getElementById("rotate")
    animateButton.addEventListener("click", function() {
        if (!spin) {
            spin = true
        } else {
            spin = false;
            glob_theta = 0.0;
            gl.uniform1f(thetaLoc, glob_theta)
        }
    })

    canvas.addEventListener("mousedown", function(event){

        //Bentuk Polygon
        if(ObjShape == "polygon"){
            t = getCanvasCoordinate(event, canvas);
            gl.bindBuffer(gl.ARRAY_BUFFER, bufferId);
            gl.bufferSubData(gl.ARRAY_BUFFER, 8*index, flatten(t))

            tt = vec4(red.value/255.0 ,green.value/255.0 , blue.value/255.0 , 1.0);

            gl.bindBuffer(gl.ARRAY_BUFFER, cBufferId);
            gl.bufferSubData(gl.ARRAY_BUFFER, 16*index, flatten(tt))

            numPositions[numPolygons]++
            index++
        }

        //Bentuk persegi/rectangle
        else if(ObjShape == "rectangle"){
            drawArraysConfig = {
                "nama": ObjShape,
                "mode": gl.TRIANGLE_FAN,
                "index": index,
                "step": 4
            }
            if(first) {
                first = false;
                gl.bindBuffer( gl.ARRAY_BUFFER, bufferId)
                t[0] = getCanvasCoordinate(event, canvas);
            }
      
            else {
                first = true;
                t[2] = getCanvasCoordinate(event, canvas);
                t[1] = vec2(t[0][0], t[2][1]);
                t[3] = vec2(t[2][0], t[0][1]);
                for(var i=0; i<4; i++) gl.bufferSubData(gl.ARRAY_BUFFER, 8*(index+i), flatten(t[i]));
                index += 4;

                gl.bindBuffer( gl.ARRAY_BUFFER, cBufferId);
                var tt = vec4(red.value/255.0 ,green.value/255.0 , blue.value/255.0 , 1.0);
                for(var i=0; i<4; i++) gl.bufferSubData(gl.ARRAY_BUFFER, 16*(index-4+i), flatten(tt));
                
                // reset vertices & menambahkan ke gambar yang dibuat
                t = [];
                SHAPES.push(drawArraysConfig);
            }
        }

        //Bentuk segitiga/triangle
        else if(ObjShape == "triangle") {
            drawArraysConfig = {
                "nama": ObjShape,
                "mode": gl.TRIANGLE_FAN,
                "index": index,
                "step": 3
            }
            gl.bindBuffer( gl.ARRAY_BUFFER, bufferId);
            if(first) {  
                first = false;
                t[0] = getCanvasCoordinate(event, canvas)
            }
    
            else {
                if(t.length == 1) {
                    t[1] = getCanvasCoordinate(event, canvas)
                }
                else {
                    first = true;
                    t[2] = getCanvasCoordinate(event, canvas)

                    for(var i=0; i<3; i++) gl.bufferSubData(gl.ARRAY_BUFFER, 8*(index+i), flatten(t[i]));
                    index += 3;
        
                    gl.bindBuffer( gl.ARRAY_BUFFER, cBufferId);
                    var tt = vec4(red.value/255.0 ,green.value/255.0 , blue.value/255.0 , 1.0);
                    for(var i=0; i<3; i++) gl.bufferSubData(gl.ARRAY_BUFFER, 16*(index-3+i), flatten(tt))

                    // reset vertices & menambahkan ke gambar yang dibuat
                    t = [];
                    SHAPES.push(drawArraysConfig);
                }
            }
        }

        //bentuk garis/line
        else if(ObjShape == "line") {
            drawArraysConfig = {
                "nama": ObjShape,
                "mode": gl.LINES,
                "index": index,
                "step": 2
            }
            console.log(ObjShape)
            gl.bindBuffer( gl.ARRAY_BUFFER, bufferId);
            if(first) {  
                first = false;
                t[0] = getCanvasCoordinate(event, canvas)
            }
    
            else {
                first = true
                t[1] = getCanvasCoordinate(event, canvas)
                
                for(var i=0; i<2; i++) gl.bufferSubData(gl.ARRAY_BUFFER, 8*(index+i), flatten(t[i]));
                index += 2;
    
                gl.bindBuffer(gl.ARRAY_BUFFER, cBufferId);
                var tt = vec4(red.value/255.0 ,green.value/255.0 , blue.value/255.0 , 1.0);
                for(var i=0; i<2; i++) gl.bufferSubData(gl.ARRAY_BUFFER, 16*(index-2+i), flatten(tt))
    
                // reset vertices & add line to SHAPES
                t = [];
                SHAPES.push(drawArraysConfig)
            }
        }
    });
    if(ObjShape != "polygon") {
        render();
    }   
}

// fungsi render gambar
function render() {
    gl.clear( gl.COLOR_BUFFER_BIT );

    if(spin) {
        glob_theta += 0.1;
        gl.uniform1f(thetaLoc, glob_theta)
    }
    for(var i = 0; i<SHAPES.length; i++){
        var obj = SHAPES[i];
        gl.drawArrays( obj["mode"], obj["index"], obj["step"] );
    }
    setTimeout(() => {
        requestAnimationFrame(render)
    }, speed);
}

//fungsi untuk mendapatkan koordinat pada saat mousedown event
function getCanvasCoordinate(event, canvas) {
    const rect = canvas.getBoundingClientRect();
    const x = event.clientX - rect.left;
    const y = event.clientY - rect.top;
    const width = canvas.width;
    const height = canvas.height;
    const pixelRatio = window.devicePixelRatio;
  
    return vec2((x * pixelRatio * 2) / width - 1, 1 - (y * pixelRatio * 2) / height);
}

//fungsi untuk mendapatkan konfigurasi RGB
function updateColor() {
    const r = red.value;
    const g = green.value;
    const b = blue.value;
    const rgb = `rgb(${r}, ${g}, ${b})`;
    color.value = rgb;
    color.style.backgroundColor = rgb;
}
